module.exports = {
    env: {
        browser: true,
        worker: true,
        serviceworker: true,
        jquery: true,
        es6: true,
        node: true,
    },
    extends: [
        "eslint:recommended",
        "plugin:import/errors",
        "plugin:import/typescript",
        "plugin:@typescript-eslint/eslint-recommended",
        "plugin:@typescript-eslint/recommended",
        "airbnb",
        "prettier",
        "plugin:security/recommended",
        "plugin:sonarjs/recommended",
    ],
    globals: {
        Atomics: "readonly",
        SharedArrayBuffer: "readonly",
    },
    parser: "@typescript-eslint/parser",
    parserOptions: {
        ecmaVersion: 2018,
        sourceType: "module",
        ecmaFeatures: {
            impliedStrict: true,
            modules: true,
        },
    },
    plugins: ["json", "import", "notice", "markdown", "angular", "prettier", "security", "sonarjs"],
    rules: {
        "@typescript-eslint/no-parameter-properties": "allow",
        "prettier/prettier": "error",
        "no-await-in-loop": "error",
        "no-console": ["error", { allow: ["warn", "error", "dir"] }],
        "default-case": "error",
        "global-require": "error",
        "callback-return": "error",
        "handle-callback-err": "error",

        // possible errors
        "for-direction": "error",
        "no-prototype-builtins": "error",
        "no-template-curly-in-string": "error",
        "no-unsafe-negation": "error",

        // best practices
        "no-underscore-dangle": ["error", { allowAfterThis: true }],
        "array-callback-return": "error",
        "block-scoped-var": "error",
        complexity: "error",
        "consistent-return": "error",
        eqeqeq: ["error", "smart"],
        "guard-for-in": "error",
        "no-alert": "error",
        "no-caller": "error",
        "no-div-regex": "error",
        "no-eval": "error",
        "no-extend-native": "error",
        "no-extra-bind": "error",
        "no-extra-label": "error",
        "no-floating-decimal": "error",
        "no-implied-eval": "error",
        "no-iterator": "error",
        "no-labels": "error",
        "no-lone-blocks": "error",
        "no-loop-func": "error",
        "no-new": "error",
        "no-new-func": "error",
        "no-new-wrappers": "error",
        "no-proto": "error",
        "no-restricted-properties": "error",
        "no-return-assign": "error",
        "no-return-await": "error",
        "no-self-compare": "error",
        "no-sequences": "error",
        "no-throw-literal": "error",
        "no-unmodified-loop-condition": "error",
        "no-unused-expressions": "error",
        "no-useless-call": "error",
        "no-useless-concat": "error",
        "no-useless-constructor": "off",
        "no-useless-escape": "error",
        "no-useless-return": "error",
        "no-void": "error",
        "no-with": "error",
        radix: "error",
        "require-await": "error",
        "wrap-iife": "error",
        yoda: "error",

        "class-methods-use-this": "off",

        // es2015
        "no-duplicate-imports": "error",
        "no-useless-computed-key": "error",
        "no-useless-rename": "error",
        "no-var": "error",
        "object-shorthand": "error",
        "prefer-arrow-callback": "error",
        "prefer-const": "error",
        "prefer-destructuring": ["warn", { object: true, array: false }],
        "prefer-numeric-literals": "warn",
        "prefer-rest-params": "warn",
        "prefer-spread": "warn",

        // disabled because of the usage of typescript-eslint-parser
        // "no-undef": "off",
        "no-unused-vars": "off",
        camelcase: "off",

        // typescript

        "@typescript-eslint/camelcase": ["error", { properties: "never" }],
        "@typescript-eslint/explicit-member-accessibility": {
            accessibility: "explicit",
        },
        // import

        "import/extensions": "error",
        "import/first": "error",
        "import/newline-after-import": "error",
        "import/no-absolute-path": "error",
        "import/no-amd": "error",
        "import/no-deprecated": "error",
        "import/no-duplicates": "error",
        "import/no-mutable-exports": "error",
        "import/no-named-as-default": "error",
        "import/no-named-as-default-member": "error",
        "import/no-named-default": "error",
        "import/order": [
            "error",
            {
                groups: ["builtin", "external", ["index", "sibling"], ["parent", "internal"]],
                "newlines-between": "never",
            },
        ],
        "import/prefer-default-export": 0,
        // does not properly work with ts
        "import/no-unresolved": 0,

        // notice
        "notice/notice": ["error", { templateFile: "hook-scripts/copyright.ts" }],
    },
};
